
/*******************************************************************************
*
* File check2.c
*
* Copyright (C) 2014 Martin Luescher
*
* This software is distributed under the terms of the GNU General Public
* License (GPL)
*
* Checks on the programs in the modules diagram.c and sfactor.c.
*
*******************************************************************************/

#define MAIN_PROGRAM

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include "utils.h"
#include "diagrams.h"


static diagram_t **dgm1(void)
{
   int i;
   int (*v)[2];
   line_t *l;
   diagram_t **dgm;

   dgm=malloc(4*sizeof(*dgm));
   error(dgm==NULL,1,"dgm1 [check2.c]","Unable to allocate diagram array");

   dgm[0]=alloc_dgm(5,4);
   v=dgm[0][0].v;
   l=dgm[0][0].l;

   for (i=0;i<4;i++)
   {
      v[i][0]=1;
      v[i][1]=0;
   }

   v[4][0]=1;
   v[4][1]=1;

   for (i=0;i<4;i++)
      l[i].type=SCALAR;

   l[0].iv[0]=0;
   l[0].iv[1]=4;

   l[1].iv[0]=1;
   l[1].iv[1]=4;

   l[2].iv[0]=2;
   l[2].iv[1]=1;

   l[3].iv[0]=3;
   l[3].iv[1]=1;

   dgm[1]=alloc_dgm(4,4);
   v=dgm[1][0].v;
   l=dgm[1][0].l;

   for (i=0;i<4;i++)
   {
      v[i][0]=1;
      v[i][1]=0;
   }

   for (i=0;i<4;i++)
      l[i].type=SCALAR;

   l[0].iv[0]=0;
   l[0].iv[1]=1;

   l[1].iv[0]=0;
   l[1].iv[1]=1;

   l[2].iv[0]=1;
   l[2].iv[1]=2;

   l[3].iv[0]=1;
   l[3].iv[1]=2;

   dgm[2]=alloc_dgm(4,6);
   v=dgm[2][0].v;
   l=dgm[2][0].l;

   for (i=0;i<4;i++)
   {
      v[i][0]=1;
      v[i][1]=0;
   }

   for (i=0;i<6;i++)
      l[i].type=SCALAR;

   l[0].iv[0]=0;
   l[0].iv[1]=2;

   l[1].iv[0]=0;
   l[1].iv[1]=3;

   l[2].iv[0]=1;
   l[2].iv[1]=2;

   l[3].iv[0]=1;
   l[3].iv[1]=3;

   l[4].iv[0]=2;
   l[4].iv[1]=3;

   l[5].iv[0]=3;
   l[5].iv[1]=2;

   dgm[3]=alloc_dgm(2,4);
   v=dgm[3][0].v;
   l=dgm[3][0].l;

   for (i=0;i<2;i++)
   {
      v[i][0]=1;
      v[i][1]=0;
   }

   for (i=0;i<4;i++)
      l[i].type=SCALAR;

   l[0].iv[0]=0;
   l[0].iv[1]=1;

   l[1].iv[0]=0;
   l[1].iv[1]=1;

   l[2].iv[0]=1;
   l[2].iv[1]=0;

   l[3].iv[0]=0;
   l[3].iv[1]=1;

   return dgm;
}


static diagram_t **dgm2(void)
{
   int i;
   int (*v)[2];
   line_t *l;
   diagram_t **dgm;

   dgm=malloc(4*sizeof(*dgm));
   error(dgm==NULL,1,"dgm2 [check2.c]","Unable to allocate diagram array");

   dgm[0]=alloc_dgm(4,5);
   v=dgm[0][0].v;
   l=dgm[0][0].l;

   for (i=0;i<2;i++)
   {
      v[i][0]=1;
      v[i][1]=0;
   }

   for (i=2;i<4;i++)
   {
      v[i][0]=1;
      v[i][1]=1;
   }

   for (i=0;i<3;i++)
      l[i].type=GLUON;

   l[3].type=GHOST;
   l[4].type=ANTIGHOST;

   l[0].iv[0]=0;
   l[0].iv[1]=1;

   l[1].iv[0]=0;
   l[1].iv[1]=2;

   l[2].iv[0]=1;
   l[2].iv[1]=3;

   l[3].iv[0]=2;
   l[3].iv[1]=3;

   l[4].iv[0]=2;
   l[4].iv[1]=3;

   dgm[1]=alloc_dgm(6,8);
   v=dgm[1][0].v;
   l=dgm[1][0].l;

   for (i=0;i<6;i++)
   {
      v[i][0]=1;
      v[i][1]=0;
   }

   for (i=0;i<8;i++)
      l[i].type=GLUON;

   l[0].iv[0]=0;
   l[0].iv[1]=2;

   l[1].iv[0]=0;
   l[1].iv[1]=4;

   l[2].iv[0]=1;
   l[2].iv[1]=3;

   l[3].iv[0]=1;
   l[3].iv[1]=5;

   l[4].iv[0]=4;
   l[4].iv[1]=5;

   l[5].iv[0]=5;
   l[5].iv[1]=3;

   l[6].iv[0]=3;
   l[6].iv[1]=2;

   l[7].iv[0]=2;
   l[7].iv[1]=4;

   dgm[2]=alloc_dgm(6,8);
   v=dgm[2][0].v;
   l=dgm[2][0].l;

   for (i=0;i<2;i++)
   {
      v[i][0]=1;
      v[i][1]=0;
   }

   for (i=2;i<6;i++)
   {
      v[i][0]=1;
      v[i][1]=1;
   }

   for (i=0;i<4;i++)
      l[i].type=GLUON;

   for (i=4;i<8;i++)
      l[i].type=GHOST;

   l[0].iv[0]=0;
   l[0].iv[1]=2;

   l[1].iv[0]=0;
   l[1].iv[1]=4;

   l[2].iv[0]=1;
   l[2].iv[1]=3;

   l[3].iv[0]=1;
   l[3].iv[1]=5;

   l[4].iv[0]=4;
   l[4].iv[1]=5;

   l[5].iv[0]=5;
   l[5].iv[1]=3;

   l[6].iv[0]=3;
   l[6].iv[1]=2;

   l[7].iv[0]=2;
   l[7].iv[1]=4;

   dgm[3]=alloc_dgm(6,9);
   v=dgm[3][0].v;
   l=dgm[3][0].l;

   for (i=0;i<2;i++)
   {
      v[i][0]=2;
      v[i][1]=0;
   }

   for (i=2;i<4;i++)
   {
      v[i][0]=1;
      v[i][1]=0;
   }

   for (i=4;i<6;i++)
   {
      v[i][0]=1;
      v[i][1]=1;
   }

   for (i=0;i<7;i++)
      l[i].type=GLUON;

   for (i=7;i<9;i++)
      l[i].type=ANTIGHOST;

   l[0].iv[0]=0;
   l[0].iv[1]=1;

   l[1].iv[0]=0;
   l[1].iv[1]=1;

   l[2].iv[0]=1;
   l[2].iv[1]=1;

   l[3].iv[0]=0;
   l[3].iv[1]=2;

   l[4].iv[0]=2;
   l[4].iv[1]=3;

   l[5].iv[0]=3;
   l[5].iv[1]=2;

   l[6].iv[0]=3;
   l[6].iv[1]=4;

   l[7].iv[0]=4;
   l[7].iv[1]=5;

   l[8].iv[0]=5;
   l[8].iv[1]=4;

   return dgm;
}


static diagram_t **dgm3(void)
{
   int i;
   int (*v)[2];
   line_t *l;
   diagram_t **dgm;

   dgm=malloc(4*sizeof(*dgm));
   error(dgm==NULL,1,"dgm3 [check2.c]","Unable to allocate diagram array");

   dgm[0]=alloc_dgm(6,8);
   v=dgm[0][0].v;
   l=dgm[0][0].l;

   for (i=0;i<2;i++)
   {
      v[i][0]=2;
      v[i][1]=0;
   }

   for (i=2;i<6;i++)
   {
      v[i][0]=1;
      v[i][1]=2;
   }

   for (i=0;i<5;i++)
      l[i].type=GLUON;

   for (i=5;i<8;i++)
      l[i].type=QUARK;

   l[0].iv[0]=0;
   l[0].iv[1]=1;

   l[1].iv[0]=1;
   l[1].iv[1]=0;

   l[2].iv[0]=0;
   l[2].iv[1]=2;

   l[3].iv[0]=3;
   l[3].iv[1]=1;

   l[4].iv[0]=4;
   l[4].iv[1]=1;

   l[5].iv[0]=2;
   l[5].iv[1]=3;

   l[6].iv[0]=3;
   l[6].iv[1]=2;

   l[7].iv[0]=4;
   l[7].iv[1]=5;

   dgm[1]=alloc_dgm(7,10);
   v=dgm[1][0].v;
   l=dgm[1][0].l;

   for (i=0;i<2;i++)
   {
      v[i][0]=1;
      v[i][1]=0;
   }

   v[2][0]=2;
   v[2][1]=0;

   for (i=3;i<7;i++)
   {
      v[i][0]=1;
      v[i][1]=2;
   }

   for (i=0;i<6;i++)
      l[i].type=GLUON;

   for (i=6;i<8;i++)
      l[i].type=QUARK;

   for (i=8;i<10;i++)
      l[i].type=ANTIQUARK;

   l[0].iv[0]=0;
   l[0].iv[1]=3;

   l[1].iv[0]=0;
   l[1].iv[1]=5;

   l[2].iv[0]=1;
   l[2].iv[1]=6;

   l[3].iv[0]=1;
   l[3].iv[1]=4;

   l[4].iv[0]=1;
   l[4].iv[1]=2;

   l[5].iv[0]=2;
   l[5].iv[1]=2;

   l[6].iv[0]=5;
   l[6].iv[1]=6;

   l[7].iv[0]=4;
   l[7].iv[1]=3;

   l[8].iv[0]=5;
   l[8].iv[1]=6;

   l[9].iv[0]=4;
   l[9].iv[1]=3;

   dgm[2]=alloc_dgm(5,8);
   v=dgm[2][0].v;
   l=dgm[2][0].l;

   v[0][0]=2;
   v[0][1]=0;

   for (i=1;i<5;i++)
   {
      v[i][0]=1;
      v[i][1]=2;
   }

   for (i=0;i<4;i++)
      l[i].type=GLUON;

   for (i=4;i<8;i++)
      l[i].type=QUARK;

   l[0].iv[0]=0;
   l[0].iv[1]=1;

   l[1].iv[0]=0;
   l[1].iv[1]=2;

   l[2].iv[0]=0;
   l[2].iv[1]=3;

   l[3].iv[0]=0;
   l[3].iv[1]=4;

   l[4].iv[0]=1;
   l[4].iv[1]=2;

   l[5].iv[0]=2;
   l[5].iv[1]=3;

   l[6].iv[0]=3;
   l[6].iv[1]=4;

   l[7].iv[0]=4;
   l[7].iv[1]=1;

   dgm[3]=alloc_dgm(9,12);
   v=dgm[3][0].v;
   l=dgm[3][0].l;

   for (i=0;i<2;i++)
   {
      v[i][0]=1;
      v[i][1]=2;
   }

   for (i=2;i<6;i++)
   {
      v[i][0]=1;
      v[i][1]=1;
   }

   for (i=6;i<9;i++)
   {
      v[i][0]=1;
      v[i][1]=0;
   }

   for (i=0;i<6;i++)
      l[i].type=GLUON;

   for (i=6;i<8;i++)
      l[i].type=QUARK;

   for (i=8;i<12;i++)
      l[i].type=GHOST;

   l[0].iv[0]=1;
   l[0].iv[1]=6;

   l[1].iv[0]=5;
   l[1].iv[1]=8;

   l[2].iv[0]=3;
   l[2].iv[1]=7;

   l[3].iv[0]=6;
   l[3].iv[1]=7;

   l[4].iv[0]=6;
   l[4].iv[1]=8;

   l[5].iv[0]=7;
   l[5].iv[1]=8;

   l[6].iv[0]=0;
   l[6].iv[1]=1;

   l[7].iv[0]=1;
   l[7].iv[1]=0;

   l[8].iv[0]=5;
   l[8].iv[1]=4;

   l[9].iv[0]=4;
   l[9].iv[1]=5;

   l[10].iv[0]=2;
   l[10].iv[1]=3;

   l[11].iv[0]=3;
   l[11].iv[1]=2;

   return dgm;
}


static diagram_t *cmb_dgm(diagram_t *dm1,diagram_t *dm2)
{
   int i,nv1,nv2,nl1,nl2;
   diagram_t *dms;

   nv1=(*dm1).nv;
   nv2=(*dm2).nv;
   nl1=(*dm1).nl;
   nl2=(*dm2).nl;

   dms=alloc_dgm(nv1+nv2,nl1+nl2);

   for (i=0;i<nv1;i++)
   {
      (*dms).v[i][0]=(*dm1).v[i][0];
      (*dms).v[i][1]=(*dm1).v[i][1];
   }

   for (i=0;i<nv2;i++)
   {
      (*dms).v[nv1+i][0]=(*dm2).v[i][0];
      (*dms).v[nv1+i][1]=(*dm2).v[i][1];
   }

   for (i=0;i<nl1;i++)
   {
      (*dms).l[i].type=(*dm1).l[i].type;
      (*dms).l[i].iv[0]=(*dm1).l[i].iv[0];
      (*dms).l[i].iv[1]=(*dm1).l[i].iv[1];
   }

   for (i=0;i<nl2;i++)
   {
      (*dms).l[nl1+i].type=(*dm2).l[i].type;
      (*dms).l[nl1+i].iv[0]=(*dm2).l[i].iv[0]+nv1;
      (*dms).l[nl1+i].iv[1]=(*dm2).l[i].iv[1]+nv1;
   }

   return dms;
}


static void check_fact(long fact,long *sf)
{
   int i;
   long f;

   f=1L;

   for (i=0;i<4;i++)
      f*=sf[i];

   error(f!=fact,1,"check_fact [check2.c]",
         "Incorrect return value of sfactor()");
}


int main(void)
{
   int i,j;
   long fact,sf[4],sfi[4],sfj[4];
   theory_t th;
   diagram_t **dgm,*dms;

   printf("\n");
   printf("Check of the programs in the modules diagram.c and sfactor.c\n");
   printf("------------------------------------------------------------\n\n");

   printf("PHI4\n");
   printf("----\n\n");

   th=PHI4;
   dgm=dgm1();

   check_dgm(th,5,dgm[0]);
   fact=sfactor(th,dgm[0],sf);
   check_fact(fact,sf);
   printf("Diagram 1: connected parts = %d (1)\n",ncparts(dgm[0]));
   printf("           quark loops = %d (0)\n",nquark_loops(dgm[0]));
   printf("           ghost loops = %d (0)\n",nghost_loops(dgm[0]));
   printf("           symmetry factor = %d (1)\n",(int)(fact/sf[3]));
   printf("           F1,..,F4 = %d,%d,%d,%d (1,1,1,432)\n\n",
          (int)(sf[0]),(int)(sf[1]),(int)(sf[2]),(int)(sf[3]));

   check_dgm(th,4,dgm[1]);
   fact=sfactor(th,dgm[1],sf);
   check_fact(fact,sf);
   printf("Diagram 2: connected parts = %d (2)\n",ncparts(dgm[1]));
   printf("           quark loops = %d (0)\n",nquark_loops(dgm[1]));
   printf("           ghost loops = %d (0)\n",nghost_loops(dgm[1]));
   printf("           symmetry factor = %d (4)\n",(int)(fact/sf[3]));
   printf("           F1,..,F4 = %d,%d,%d,%d (1,4,1,192)\n\n",
          (int)(sf[0]),(int)(sf[1]),(int)(sf[2]),(int)(sf[3]));

   check_dgm(th,4,dgm[2]);
   fact=sfactor(th,dgm[2],sf);
   check_fact(fact,sf);
   printf("Diagram 3: connected parts = %d (1)\n",ncparts(dgm[2]));
   printf("           quark loops = %d (0)\n",nquark_loops(dgm[2]));
   printf("           ghost loops = %d (0)\n",nghost_loops(dgm[2]));
   printf("           symmetry factor = %d (4)\n",(int)(fact/sf[3]));
   printf("           F1,..,F4 = %d,%d,%d,%d (2,2,1,8)\n\n",
          (int)(sf[0]),(int)(sf[1]),(int)(sf[2]),(int)(sf[3]));

   check_dgm(th,2,dgm[3]);
   fact=sfactor(th,dgm[3],sf);
   check_fact(fact,sf);
   printf("Diagram 4: connected parts = %d (1)\n",ncparts(dgm[3]));
   printf("           quark loops = %d (0)\n",nquark_loops(dgm[3]));
   printf("           ghost loops = %d (0)\n",nghost_loops(dgm[3]));
   printf("           symmetry factor = %d (48)\n",(int)(fact/sf[3]));
   printf("           F1,..,F4 = %d,%d,%d,%d (2,24,1,1)\n\n",
          (int)(sf[0]),(int)(sf[1]),(int)(sf[2]),(int)(sf[3]));

   for (i=0;i<4;i++)
      free_dgm(dgm[i]);

   free(dgm);

   printf("YM\n");
   printf("--\n\n");

   th=YM;
   dgm=dgm2();

   check_dgm(th,4,dgm[0]);
   fact=sfactor(th,dgm[0],sf);
   check_fact(fact,sf);
   printf("Diagram 1: connected parts = %d (1)\n",ncparts(dgm[0]));
   printf("           quark loops = %d (0)\n",nquark_loops(dgm[0]));
   printf("           ghost loops = %d (1)\n",nghost_loops(dgm[0]));
   printf("           symmetry factor = %d (1)\n",(int)(fact/sf[3]));
   printf("           F1,..,F4 = %d,%d,%d,%d (1,1,1,2)\n\n",
          (int)(sf[0]),(int)(sf[1]),(int)(sf[2]),(int)(sf[3]));

   check_dgm(th,6,dgm[1]);
   fact=sfactor(th,dgm[1],sf);
   check_fact(fact,sf);
   printf("Diagram 2: connected parts = %d (1)\n",ncparts(dgm[1]));
   printf("           quark loops = %d (0)\n",nquark_loops(dgm[1]));
   printf("           ghost loops = %d (0)\n",nghost_loops(dgm[1]));
   printf("           symmetry factor = %d (2)\n",(int)(fact/sf[3]));
   printf("           F1,..,F4 = %d,%d,%d,%d (2,1,1,2)\n\n",
          (int)(sf[0]),(int)(sf[1]),(int)(sf[2]),(int)(sf[3]));

   check_dgm(th,6,dgm[2]);
   fact=sfactor(th,dgm[2],sf);
   check_fact(fact,sf);
   printf("Diagram 3: connected parts = %d (1)\n",ncparts(dgm[2]));
   printf("           quark loops = %d (0)\n",nquark_loops(dgm[2]));
   printf("           ghost loops = %d (1)\n",nghost_loops(dgm[2]));
   printf("           symmetry factor = %d (1)\n",(int)(fact/sf[3]));
   printf("           F1,..,F4 = %d,%d,%d,%d (1,1,1,2)\n\n",
          (int)(sf[0]),(int)(sf[1]),(int)(sf[2]),(int)(sf[3]));

   check_dgm(th,8,dgm[3]);
   fact=sfactor(th,dgm[3],sf);
   check_fact(fact,sf);
   printf("Diagram 4: connected parts = %d (1)\n",ncparts(dgm[3]));
   printf("           quark loops = %d (0)\n",nquark_loops(dgm[3]));
   printf("           ghost loops = %d (1)\n",nghost_loops(dgm[3]));
   printf("           symmetry factor = %d (8)\n",(int)(fact/sf[3]));
   printf("           F1,..,F4 = %d,%d,%d,%d (1,4,2,1)\n\n",
          (int)(sf[0]),(int)(sf[1]),(int)(sf[2]),(int)(sf[3]));

   for (i=0;i<4;i++)
      free_dgm(dgm[i]);

   free(dgm);

   printf("QCD\n");
   printf("---\n\n");

   th=QCD;
   dgm=dgm3();

   check_dgm(th,8,dgm[0]);
   fact=sfactor(th,dgm[0],sf);
   check_fact(fact,sf);
   printf("Diagram 1: connected parts = %d (1)\n",ncparts(dgm[0]));
   printf("           quark loops = %d (1)\n",nquark_loops(dgm[0]));
   printf("           ghost loops = %d (0)\n",nghost_loops(dgm[0]));
   printf("           symmetry factor = %d (2)\n",(int)(fact/sf[3]));
   printf("           F1,..,F4 = %d,%d,%d,%d (1,2,1,1)\n\n",
          (int)(sf[0]),(int)(sf[1]),(int)(sf[2]),(int)(sf[3]));

   check_dgm(th,8,dgm[1]);
   fact=sfactor(th,dgm[1],sf);
   check_fact(fact,sf);
   printf("Diagram 2: connected parts = %d (1)\n",ncparts(dgm[1]));
   printf("           quark loops = %d (2)\n",nquark_loops(dgm[1]));
   printf("           ghost loops = %d (0)\n",nghost_loops(dgm[1]));
   printf("           symmetry factor = %d (4)\n",(int)(fact/sf[3]));
   printf("           F1,..,F4 = %d,%d,%d,%d (2,1,2,1)\n\n",
          (int)(sf[0]),(int)(sf[1]),(int)(sf[2]),(int)(sf[3]));

   check_dgm(th,6,dgm[2]);
   fact=sfactor(th,dgm[2],sf);
   check_fact(fact,sf);
   printf("Diagram 3: connected parts = %d (1)\n",ncparts(dgm[2]));
   printf("           quark loops = %d (1)\n",nquark_loops(dgm[2]));
   printf("           ghost loops = %d (0)\n",nghost_loops(dgm[2]));
   printf("           symmetry factor = %d (4)\n",(int)(fact/sf[3]));
   printf("           F1,..,F4 = %d,%d,%d,%d (4,1,1,1)\n\n",
          (int)(sf[0]),(int)(sf[1]),(int)(sf[2]),(int)(sf[3]));

   check_dgm(th,9,dgm[3]);
   fact=sfactor(th,dgm[3],sf);
   check_fact(fact,sf);
   printf("Diagram 4: connected parts = %d (1)\n",ncparts(dgm[3]));
   printf("           quark loops = %d (1)\n",nquark_loops(dgm[3]));
   printf("           ghost loops = %d (2)\n",nghost_loops(dgm[3]));
   printf("           symmetry factor = %d (1)\n",(int)(fact/sf[3]));
   printf("           F1,..,F4 = %d,%d,%d,%d (1,1,1,2)\n\n",
          (int)(sf[0]),(int)(sf[1]),(int)(sf[2]),(int)(sf[3]));

   printf("Sum of QCD diagrams\n");
   printf("-------------------\n\n");

   for (i=0;i<4;i++)
   {
      for (j=i;j<4;j++)
      {
         dms=cmb_dgm(dgm[i],dgm[j]);
         check_dgm(th,18,dms);
         fact=sfactor(th,dms,sf);
         check_fact(fact,sf);
         (void)(sfactor(th,dgm[i],sfi));
         (void)(sfactor(th,dgm[j],sfj));

         printf("Diagram %d+%d: connected parts = %d (%d)\n",i+1,j+1,
                ncparts(dms),ncparts(dgm[i])+ncparts(dgm[j]));

         printf("             quark loops = %d (%d)\n",
                nquark_loops(dms),nquark_loops(dgm[i])+nquark_loops(dgm[j]));

         printf("             ghost loops = %d (%d)\n",
                nghost_loops(dms),nghost_loops(dgm[i])+nghost_loops(dgm[j]));

         if ((i==2)&&(j==2))
            printf("           F1,..,F4 = %d,%d,%d,%d (%d,%d,%d,%d)\n\n",
                   (int)(sf[0]),(int)(sf[1]),(int)(sf[2]),(int)(sf[3]),
                   (int)(2L*sfi[0]*sfj[0]),(int)(sfi[1]*sfj[1]),
                   (int)(sfi[2]*sfj[2]),(int)(2L*sfi[3]*sfj[3]));
         else if (i==j)
            printf("           F1,..,F4 = %d,%d,%d,%d (%d,%d,%d,%d)\n\n",
                   (int)(sf[0]),(int)(sf[1]),(int)(sf[2]),(int)(sf[3]),
                   (int)(sfi[0]*sfj[0]),(int)(sfi[1]*sfj[1]),
                   (int)(sfi[2]*sfj[2]),(int)(2L*sfi[3]*sfj[3]));
         else
            printf("           F1,..,F4 = %d,%d,%d,%d (%d,%d,%d,%d)\n\n",
                   (int)(sf[0]),(int)(sf[1]),(int)(sf[2]),(int)(sf[3]),
                   (int)(sfi[0]*sfj[0]),(int)(sfi[1]*sfj[1]),
                   (int)(sfi[2]*sfj[2]),(int)(sfi[3]*sfj[3]));
      }
   }

   for (i=0;i<4;i++)
      free_dgm(dgm[i]);

   free(dgm);

   exit(0);
}
