
/*******************************************************************************
*
* File check1.c
*
* Copyright (C) 2014 Martin Luescher
*
* This software is distributed under the terms of the GNU General Public
* License (GPL)
*
* Sorting of a tupel list.
*
*******************************************************************************/

#define MAIN_PROGRAM

#include <stdlib.h>
#include <stdio.h>
#include <math.h>
#include "utils.h"
#include "tupel.h"

static int data[4][3]={{1,2,3},{0,0,2},{1,1,1},{2,2,1}};


static void print_tp(tupel_t *tp)
{
   int n,*i,*im;

   n=(*tp).n;
   i=(*tp).i;
   im=i+n;

   if (n==0)
      printf("n=%d\n",n);
   else
   {
      printf("n=%d, i=[%d",n,i[0]);
      i+=1;

      for (;i<im;i++)
         printf(",%d",i[0]);

      printf("]\n");
   }
}


static void print_tpl(tplist_t *tpl)
{
   int n,i;
   tupel_t **tpa;

   n=(*tpl).n;
   tpa=(*tpl).tpa;

   printf("Tupel list with %d elements\n",n);

   for (i=0;i<n;i++)
      print_tp(tpa[i]);

   printf("\n");
}


int main(void)
{
   int i,j;
   tupel_t *tp;
   tplist_t *tpl;

   printf("\n");
   printf("Sorting of a tupel list\n");
   printf("-----------------------\n\n");

   tpl=alloc_tplist(1);

   for (i=0;i<4;i++)
   {
      tp=alloc_tp(3);

      for (j=0;j<3;j++)
         (*tp).i[j]=data[i][j];

      add_tp(tp,tpl);
   }

   print_tpl(tpl);

   for (i=0;i<4;i++)
      error(i!=fnd_tp((*tpl).tpa[i],tpl),1,"main [check1.c]",
            "fnd_tp() is incorrect");

   sort_tplist(tpl);
   printf("After sorting:\n");
   print_tpl(tpl);

   for (i=0;i<4;i++)
      error(i!=fnd_tp((*tpl).tpa[i],tpl),1,"main [check1.c]",
            "fnd_tp() is incorrect");

   tp=alloc_tp(2);
   (*tp).i[0]=0;
   (*tp).i[1]=0;

   error(4!=fnd_tp(tp,tpl),1,"main [check1.c]",
         "fnd_tp() is incorrect");

   exit(0);
}
