
/*******************************************************************************
*
* File check1.c
*
* Copyright (C) 2014 Martin Luescher
*
* This software is distributed under the terms of the GNU General Public
* License (GPL)
*
* Simple checks of the GMP rational-number programs.
*
*******************************************************************************/

#define MAIN_PROGRAM

#include <stdlib.h>
#include <stdio.h>
#include <math.h>
#include <gmp.h>
#include <limits.h>


int main(void)
{
   mpq_t r1,r2,r3;
   mpq_t r4,r5,r6,r7;
   char *s1,*s2,*s3,*s4,*s5,*s6,*s7;

   printf("\n");
   printf("Rational number arithmetic\n");
   printf("--------------------------\n\n");

   mpq_init(r1);
   mpq_init(r2);
   mpq_init(r3);

   mpq_init(r4);
   mpq_init(r5);
   mpq_init(r6);
   mpq_init(r7);

   mpq_set_si(r2,325L,15L);
   mpq_canonicalize(r2);
   mpq_set_si(r3,-7L,384L);
   mpq_canonicalize(r3);

   s1=mpq_get_str(NULL,10,r1);
   s2=mpq_get_str(NULL,10,r2);
   s3=mpq_get_str(NULL,10,r3);

   printf("r1=%s (should be 0)\n",s1);
   printf("r2=%s (should be 65/3)\n",s2);
   printf("r3=%s (should be -7/384)\n\n",s3);

   mpq_add(r4,r2,r3);
   mpq_sub(r5,r2,r3);
   mpq_mul(r6,r2,r3);
   mpq_div(r7,r2,r3);

   s4=mpq_get_str(NULL,10,r4);
   s5=mpq_get_str(NULL,10,r5);
   s6=mpq_get_str(NULL,10,r6);
   s7=mpq_get_str(NULL,10,r7);

   printf("r2+r3=%s (should be 2771/128)\n",s4);
   printf("r2-r3=%s (should be 8327/384)\n",s5);
   printf("r2*r3=%s (should be -455/1152)\n",s6);
   printf("r2/r3=%s (should be -8320/7)\n\n",s7);

   exit(0);
}
