
/*******************************************************************************
*
* File linalg.h
*
* Copyright (C) 2011, 2015 Martin Luescher
*
* This software is distributed under the terms of the GNU General Public
* License (GPL)
*
*******************************************************************************/

#ifndef LINALG_H
#define LINALG_H

#ifndef SL3_H
#include "sl3.h"
#endif

/* CMATRIX_DBLE_C */
extern void cmat_vec_dble(int n,complex_dble *a,complex_dble *v,
                          complex_dble *w);
extern void cmat_vec_assign_dble(int n,complex_dble *a,complex_dble *v,
                                 complex_dble *w);
extern void cmat_add_dble(int n,complex_dble *a,complex_dble *b,
                          complex_dble *c);
extern void cmat_sub_dble(int n,complex_dble *a,complex_dble *b,
                          complex_dble *c);
extern void cmat_mul_dble(int n,complex_dble *a,complex_dble *b,
                          complex_dble *c);
extern void cmat_dag_dble(int n,complex_dble *a,complex_dble *b);
extern int cmat_inv_dble(int n,complex_dble *a,complex_dble *b,double *k);

/* LIEALG_C */
extern void random_alg(int vol,su3_alg_dble *X);
extern double norm_square_alg(int vol,int icom,su3_alg_dble *X);
extern double scalar_prod_alg(int vol,int icom,su3_alg_dble *X,su3_alg_dble *Y);
extern void set_alg2zero(int vol,su3_alg_dble *X);
extern void assign_alg2alg(int vol,su3_alg_dble *X,su3_alg_dble *Y);
extern void mulr_add_alg(int vol,su3_alg_dble *X,su3_alg_dble *Y,double r);

/* SALG_DBLE_C */
extern complex_dble spinor_prod_dble(int vol,int icom,spinor_dble *s,
                                     spinor_dble *r);
extern double spinor_prod_re_dble(int vol,int icom,spinor_dble *s,
                                  spinor_dble *r);
extern complex_dble spinor_prod5_dble(int vol,int icom,spinor_dble *s,
                                      spinor_dble *r);
extern double norm_square_dble(int vol,int icom,spinor_dble *s);
extern void mulc_spinor_add_dble(int vol,spinor_dble *s,spinor_dble *r,
                                 complex_dble z);
extern void mulr_spinor_add_dble(int vol,spinor_dble *s,spinor_dble *r,
                                 double c);
extern void combine_spinor_dble(int vol,spinor_dble *s,spinor_dble *r,
                                double cs,double cr);
extern void project_dble(int vol,int icom,spinor_dble *s,spinor_dble *r);
extern void scale_dble(int vol,double c,spinor_dble *s);
extern double normalize_dble(int vol,int icom,spinor_dble *s);
extern void rotate_dble(int vol,int n,spinor_dble **ppk,complex_dble *v);
extern void mulg5_dble(int vol,spinor_dble *s);
extern void mulmg5_dble(int vol,spinor_dble *s);

/* SL3ALG */
extern void random_calg(int vol,sl3_alg_dble *X);
extern void random_calg2(int vol,sl3_alg_dble *X);
extern double norm_square_calg(int vol,int icom,sl3_alg_dble *X);
extern complex_dble scalar_prod_calg(int vol,int icom,sl3_alg_dble *X,
                                     sl3_alg_dble *Y);
extern void set_calg2zero(int vol,sl3_alg_dble *X);
extern void assign_calg2calg(int vol,sl3_alg_dble *X,sl3_alg_dble *Y);
extern void assign_calgdag2calg(int vol,sl3_alg_dble *X,sl3_alg_dble *Y);
extern void add_calg(int vol,sl3_alg_dble *X,sl3_alg_dble *Y);
extern void sub_calg(int vol,sl3_alg_dble *X,sl3_alg_dble *Y);
extern void mulr_calg(int vol,double r,sl3_alg_dble *X,sl3_alg_dble *Y);
extern void mulr_add_calg(int vol,sl3_alg_dble *X,sl3_alg_dble *Y,double r);
extern void mulc_add_calg(int vol,sl3_alg_dble *X,sl3_alg_dble *Y,
                          complex_dble z);

/* VALG_DBLE_C */
extern complex_dble vprod_dble(int n,int icom,complex_dble *v,complex_dble *w);
extern double vnorm_square_dble(int n,int icom,complex_dble *v);
extern void mulc_vadd_dble(int n,complex_dble *v,complex_dble *w,
                           complex_dble z);
extern void vproject_dble(int n,int icom,complex_dble *v,complex_dble *w);
extern void vscale_dble(int n,double r,complex_dble *v);
extern double vnormalize_dble(int n,int icom,complex_dble *v);
extern void vrotate_dble(int n,int nv,complex_dble **pv,complex_dble *a);

#endif
