
/*******************************************************************************
*
* File plots.h
*
* Copyright (C) 2014 Martin Luescher
*
* This software is distributed under the terms of the GNU General Public
* License (GPL)
*
*******************************************************************************/

#ifndef PLOT_H
#define PLOT_H

#ifndef UTILS_H
#include "utils.h"
#endif

#ifndef TREES_H
#include "trees.h"
#endif

#define SCALE_FACTOR 1.4
#define XSIZE 480.0
#define YSIZE 728.0
#define HSPACE (SCALE_FACTOR*25.0)
#define VSPACE (SCALE_FACTOR*25.0)
#define TXTSIZE (SCALE_FACTOR*8.0)
#define TXTSEP (SCALE_FACTOR*4.5)
#define TXTUP (SCALE_FACTOR*1.0)

/* PTOOLS_C */
extern void start_plot(FILE *plot,int nc);
extern void end_plot(void);
extern void set_point(double *pos);
extern void get_point(double *pos);
extern void move_point(double phi,double *vec);
extern void draw_line(ltype_t lt,double angle,double *vec);
extern void draw_labeled_line(ltype_t lt,double phi,double *vec,int lbl);
extern void draw_rooted_line(ltype_t lt,double phi,double *vec);
extern void draw_vertex(vtype_t vt);
extern void draw_coefficient(cnum_t *cn);
extern void start_bbox(void);
extern void end_bbox(double *pos1,double *pos2);
extern void start_diagram(double *pos1,double *pos2);
extern void end_diagram(void);

/* PBRANCH_C */
extern void draw_branch(branch_t *br,vlist_t *vl);

/* PTREE_C */
extern void draw_tree(diagram_t *dm,vlist_t *vl);

/* PLTREE_C */
extern void draw_ltree0(ltree_t *ltd,vlist_t *vl);
extern void draw_ltree1(cnum_t *cn,ltree_t *ltd,vlist_t *vl);

#endif
