
/*******************************************************************************
*
* File vxfcts.h
*
* Copyright (C) 2015 Martin Luescher
*
* This software is distributed under the terms of the GNU General Public
* License (GPL)
*
*******************************************************************************/

#ifndef VXFCTS_H
#define VXFCTS_H

#ifndef SL3_H
#include "sl3.h"
#endif

#if ((defined VXGEN_C)||(defined AGN_C)||(defined AMN_C)|| \
     (defined AFPN_C)||(defined CBFPN_C)||(defined CFPN_C))
#if (defined NMAX)
#undef NMAX
#endif
#define NMAX 12
#endif

/* VXGEN_C */
extern int bcount(int n,unsigned int x);
extern unsigned int binsert(int n,unsigned int x,unsigned int y);
extern unsigned int bsubset(int n,unsigned int x,unsigned int y);
extern double bernoulli(int n);
extern void sym_prod(int type,int n,su3_dble *X,su3_dble *PX);

/* AFPN_C */
extern void AFPn(int n,sl3_alg_dble **asrc,sl3_alg_dble *cbsrc,
                 sl3_alg_dble *csrc,sl3_alg_dble *vxfld);

/* AGF_C */
extern void Agf(sl3_alg_dble *asrc,sl3_alg_dble *vxfld);

/* AGN_C */
extern void AGn(int n,sl3_alg_dble **asrc,sl3_alg_dble *vxfld);

/* AMN_C */
extern void Amn(int n,sl3_alg_dble **asrc,sl3_alg_dble *vxfld);

/* CBFPN_C */
extern void CbFPn(int n,sl3_alg_dble **asrc,sl3_alg_dble *cbsrc,
                  sl3_alg_dble *vxfld);

/* CFPN_C */
extern void CFPn(int n,sl3_alg_dble **asrc,sl3_alg_dble *csrc,
                 sl3_alg_dble *vxfld);

#endif
